// Copyright (c); 2014-2020 NetEase, Inc.
// All right reserved.

part of room_kit;

/// 在房间里获取美颜控制器实例.
class _NEInRoomUserControllerImpl extends NEInRoomUserController with _RoomAloggerMixin {

  final _InRoomData roomData;

  _NEInRoomUserControllerImpl(this.roomData);

  @override
  Future<NEResult<void>> changeMyName(String name) {
    apiLogger.i('changeMyName: $name');
    return InRoomRepository.modifyNickname(roomData.roomId, name);
  }

  @override
  Future<NEResult<void>> makeHost(String userId) {
    apiLogger.i('makeHost: $userId ${roomData.getUserName(userId)}');
    return InRoomRepository.changeHost(roomData.roomId, [userId]);
  }

  @override
  Future<NEResult<void>> removeUser(String userId) {
    apiLogger.i('removeUser: $userId ${roomData.getUserName(userId)}');
    return InRoomRepository.hostRemoveMember(roomData.roomId, [userId]);
  }
}
