// Copyright (c) 2014-2021 NetEase, Inc.
// All right reserved.

part of room_kit;
/// 房间直播控制器
abstract class NEInRoomLiveStreamController {

  /// 查询直播是否正在进行中
  bool isLiveStreamEnabled();

  /// 获取当前直播信息
  NEInRoomLiveInfo? getLiveStreamInfo();

  /// 主持人开启直播
  Future<NEResult<NEInRoomLiveInfo>> startLiveStream(NEInRoomLiveInfo live);

  /// 主持人更新直播状态
  Future<NEResult<NEInRoomLiveInfo>> updateLiveStream(NEInRoomLiveInfo live);

  /// 主持人结束直播
  Future<NEResult<void>> stopLiveStream();

}