// Copyright (c) 2014-2021 NetEase, Inc.
// All right reserved.
part of room_kit;

/// 屏幕共享控制器
abstract class NEInRoomScreenShareController {

  /// 其他人是否正在共享屏幕
  bool isOtherSharing();

  /// 本端是否正在共享屏幕
  bool isSharingScreen();

  /// 获取当前正在屏幕共享的用户ID
  String? getScreenSharingUserId();

  /// 开启本地屏幕共享
  /// [config] 屏幕共享相关参数
  /// [broadcastAppGroup] ios屏幕共享必需
  Future<NEResult<void>> startScreenShare([NERtcScreenConfig? config, String? broadcastAppGroup]);

  /// 停止本地屏幕共享
  Future<NEResult<void>> stopScreenShare();

  /// 主持人操作停止用户屏幕共享
  Future<NEResult<void>> stopParticipantScreenShare(String userId);
}