// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.
part of room_kit;

class _NESettingsServiceImpl extends NESettingsService {
  static const _tag = 'NESettingsServiceImpl';

  static final _NESettingsServiceImpl _instance = _NESettingsServiceImpl._();

  factory _NESettingsServiceImpl() => _instance;

  _NESettingsServiceImpl._();

  @override
  bool isBeautySupported() {
    return SettingsRepository.isBeautyFaceSupported();
  }

  @override
  bool isChatroomSupported() {
    return SettingsRepository.isMeetingChatSupported();
  }

  @override
  bool isCloudRecordSupported() {
    return SettingsRepository.isMeetingCloudRecordSupported();
  }

  @override
  bool isLiveStreamSupported() {
    return SettingsRepository.isMeetingLiveSupported();
  }

  @override
  bool isWhiteboardSupported() {
    return SettingsRepository.isMeetingWhiteboardSupported();
  }

  @override
  bool isScreenShareSupported() {
    if (defaultTargetPlatform == TargetPlatform.iOS) {
      final osVer = '${DeviceInfo.osVer}.0';
      return (double.tryParse(osVer.substring(0, osVer.indexOf(r'.'))) ?? 0) >= 12;
    }
    return defaultTargetPlatform == TargetPlatform.android;
  }
}
