// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_kit;

/// 在房间里获取聊天消息实例.
abstract class InRoomChatMessage {
  ///获取聊天消息类型
  int getChatMessageType();

  ///获取聊天内容
  String getContent();

  /// 获取消息ID
  String getMsgId();

  ///获取接收消息的用户的屏幕名称。
  String getReceiverDisplayName();

  ///获取接收消息的用户的ID
  String getReceiverUserId();

  ///获取发送消息的用户的屏幕名称
  String getSenderDisplayName();

  ///获取发送消息的用户的ID
  String getSenderUserId();

  /// 获取消息发送的时间。
  int getTime();

  ///检查消息是否发送给会议中的所有用户
  bool isChatToAll();

  ///检查消息是否发送给所有参加会议的小组成员
  bool isChatToAllPanelist();

  ///检查消息是否发送给等待室用户
  bool isChatToWaitingRoom();

  /// 发送消息给所有用户
  void setChatToAll(bool chatToAll);

  /// 发送消息给所有参加会议的小组成员
  void setChatToAllPanelist(bool chatToAllPanelist);

  ///发送消息给等待室用户
  void setChatToWaitingRoom(bool chatToWaitingRoom);
}

enum ChatMessageType {
  all,
  allPanelist,
  individual,
  individualPanelist,
  none,
  waitingRoomUsers,
}
