// Copyright (c) 2014-2021 NetEase, Inc.
// All right reserved.

part of room_kit;

class NEInRoomServiceListener {

  /// 用户加入房间回调
  void onRoomUserJoin(List<NEInRoomUserInfo> userList) {}

  /// 用户离开房间回调
  void onRoomUserLeave(List<NEInRoomUserInfo> userList) {}

  /// 用户昵称变更回调
  void onRoomUserNameChanged(String userId, String name) {}

  /// 房间主持人变更回调
  void onRoomHostChanged(String userId) {}

  /// 房间麦克风用户视频变更回调
  void onRoomActiveSpeakerVideoUserChanged(String userId) {}

  void onRoomRemoteAudioVolumeIndication(List<NERoomUserAudioVolumeInfo> volumeList, int totalVolume) {}

  /// 焦点视频状态变化回调
  void onRoomUserVideoPinStatusChanged(String userId, bool isPinned) {}

  /// 房间成员视频状态变更回调
  void onRoomUserVideoStatusChanged(String userId, NERoomVideoStatus status) {}

  /// 房间成员音频状态变更回调
  void onRoomUserAudioStatusChanged(String userId, NERoomAudioStatus status) {}

  /// 房间成员屏幕共享状态变更回调
  void onRoomUserScreenShareStatusChanged(String userId, NERoomScreenShareStatus status) {}

  /// 房间成员白板共享状态变更回调
  void onRoomUserWhiteBoardShareStatusChanged(String userId, NERoomWhiteBoardShareStatus status) {}

  /// 房间举手状态变更回调
  void onRoomRaiseHandStatusChanged(String userId, NERaiseHandDetail raiseHandDetail) {}

  /// 接收到房间聊天室消息回调
  void onRoomChatMessageReceived(List<NEChatRoomMessage> message) {}

  /// 房间静音模式变更回调
  void onRoomSilentModeChanged(bool inSilentMode) {}

  /// 房间锁定状态变更回调
  void onRoomLockStatusChanged(bool isLock) {}

  /// 直播状态变更通知
  void onRoomLiveStreamStatusChanged(NERoomItemLiveState status) {}

  /// 直播信息变更通知
  void onRoomLiveStreamInfoChanged(NEInRoomLiveInfo info) {}

  ///白板编辑权限变更
  void onRoomUserWhiteBoardInteractionStatusChanged(String userId,bool enable){}
}

class NERoomUserAudioVolumeInfo {
  /// 用户 ID
  final String userId;
  /// 音量[0-100]
  final int volume;

  NERoomUserAudioVolumeInfo(this.userId, this.volume);
}
