// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.
part of room_kit;

abstract class NERoomInfo {

  /// 预定成功后， 服务器生成唯一id
  int get uniqueId;

  /// 房间ID
  String get roomId;

  /// 短号ID
  String? get shortRoomId;

  /// Sip会议ID
  String? get sipCid;

  /// 类型
  /// [NERoomType]
  int get type;

  /// 主题
  String get subject;

  /// 密码
  String? get password;

  /// 预约开始时间
  int get scheduleStartTime;

  /// 预约结束时间
  int get scheduleEndTime;

  /// 是否有全体禁音，0：否，1：有
  bool get audioAllMute;

  /// 是否锁定
  bool get locked;

  /// 主持人帐号id
  String get hostUserId;

  /// 焦点视频帐号id
  String? get pinnedUserId;

  /// 屏幕共享者
  String? get screenSharingUserId;

  /// 白板共享者
  String? get whiteboardSharingUserId;

  /// 设置
  NERoomItemSettings? get settings;

  /// 直播设置
  NEInRoomLiveInfo? get liveStreamInfo;

  /// 成员列表
  List<NEInRoomUserInfo> get userList;

}