// Copyright (c) 2014-2021 NetEase, Inc.
// All right reserved.

part of room_kit;

/// 房间内直播条目
abstract class NEInRoomLiveInfo {

  NEInRoomLiveInfo._();

  factory NEInRoomLiveInfo() {
    return _InRoomLiveInfo.empty();
  }

  bool get enable;

  String? get title;

  set title(String? title);

  String? get password;

  /// 直播密码
  set password(String? password);

  /// 直播状态
  NERoomItemLiveState get state;

  /// 是否开启聊天室
  set liveChatRoomEnable(bool liveChatRoomEnable);

  bool get liveChatRoomEnable;

  /// 直播布局
  set liveLayout(NELiveLayout liveLayout);

  NELiveLayout get liveLayout;

  /// 直播聊天室id
  String? get chatRoomId;

  set userList(List<String>? userList);

  List<String>? get userList;

  /// hls 拉流地址
  String? get hlsPullUrl;

  /// http 拉流地址
  String? get httpPullUrl;

  /// rtmp 拉流地址
  String? get rtmpPullUrl;

  /// 直播地址
  String? get liveUrl;

  NELiveAuthLevel get webAccessControlLevel;

  set webAccessControlLevel(NELiveAuthLevel level);
}