// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.
part of room_kit;

/// 房间设置服务，可设置入会时、房间中的一些配置信息
/// 如入会时的音视频开关选项，如果在入会时未指定[NERoomOptions]，则使用该设置服务提供的默认值
/// 该设置服务使用设备本地存储，暂不支持漫游
abstract class NESettingsService extends ValueNotifier<Map> {

  NESettingsService() : super({});

  ///查询是否开启美颜功能
  bool isBeautySupported();

  /// 是否允许开启直播
  bool isLiveStreamSupported();

  /// 查询白板服务开关状态
  /// return true-打开，false-关闭
  bool isWhiteboardSupported();

  ///查询是否为当前用户启用了云端录制，房间内本地属性
  bool isCloudRecordSupported();

  ///查询当前应用是否支持聊天室功能
  bool isChatroomSupported();

  /// 屏幕共享功能是否可用
  /// Android 均支持
  /// iOS 12以上才支持
  bool isScreenShareSupported();
}


