// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _ApiHelper {
  static Future<NEResult<T>> _execute<T>(BaseApi api) {
    return api.execute().then((result) {
      if (api.checkLoginState() &&
          (result.code == RoomErrorCode.verifyError ||
              result.code == RoomErrorCode.tokenError)) {
        _AuthManager().tokenIllegal(RoomErrorCode.getMsg(result.msg, 'Token失效'));
      }
      return NEResult(code: result.code, msg: result.msg, data: result.data as T?);
    });
  }
}
