// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

/// auth state
class AuthState {
  /// 无账号
  static const int idle = 0;

  /// 有账号密码，可以自动登录
  static const int unAuth = 1;

  /// 正在登录
  static const int authorizing = 2;

  /// 已登录
  static const int authorized = 3;

  /// 退出
  static const int unAuthorizing = 4;

  /// token 过期
  static const int tokenExpired = 5;

  /// 其他端登陆同时入会，被踢
  static const int kickOut = 6;
  
  static String stringify(int state) {
    switch(state) {
      case idle: return 'idle';
      case unAuth: return 'unAuth';
      case authorizing: return 'authorizing';
      case authorized: return 'authorized';
      case unAuthorizing: return 'unAuthorizing';
      case tokenExpired: return 'tokenExpired';
      case kickOut: return 'kickOut';
      default: return 'unknown';
    }
  }

}
