// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class ServersConfig {
  static final String _serverUrl = 'https://meeting-api.netease.im';

  int get connectTimeout => 30000;

  int get receiveTimeout => 10000;

  static final ServersConfig _instance = ServersConfig._();

  ServersConfig._();

  factory ServersConfig() => _instance;

  bool _serverUrlTouched = false;

  String? _privateServerUrl;

  set serverUrl(String url) {
    assert(
        !_serverUrlTouched, 'Cannot set server url after it has been touched');
    if (_privateServerUrl == null && TextUtils.isNotEmpty(url)) {
      _privateServerUrl = url;
      Alog.i(
          tag: 'ServersConfig', moduleName: _moduleName, content: 'set private server url: $url');
    }
  }

  String get baseUrl {
    assert(() {
      _serverUrlTouched = true;
      return true;
    }());
    var baseUrl = TextUtils.isNotEmpty(_privateServerUrl)
        ? _privateServerUrl
        : _serverUrl;
    return baseUrl!;
  }
}
