// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

abstract class AVState {
  static const int open = 1;

  static const int close = 2;

  static const int hostClose = 3;

  static const int waitingOpen = 4;

  static int state(bool isOpen) {
    return isOpen ? AVState.open : AVState.close;
  }

  static bool isMute(int? avState) {
    return avState != open;
  }
}

/// video state
class VideoState extends AVState {
  static int state(bool isOpen) {
    return AVState.state(isOpen);
  }
}

/// audio state
class AudioState extends AVState{

  static int state(bool isOpen){
    return AVState.state(isOpen);
  }
}
