// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _RoomItemImpl extends NERoomItem {

  _RoomItemImpl() : super._();

  int? _meetingUniqueId;

  String? _roomId;

  String? _subject;

  int? _startTime;

  int? _endTime;

  String? _password;

  NERoomItemSettings? _setting;

  NERoomItemStatus _status = NERoomItemStatus.invalid;

  int? _updateTime;

  int? _createTime;

  NEPreRoomLiveInfo? _live;

  String? _sipCid;

  @override
  int? get roomUniqueId => _meetingUniqueId;

  @override
  String? get roomId => _roomId;

  @override
  String? get subject => _subject;

  @override
  int get startTime => _startTime ?? 0;

  @override
  int get endTime => _endTime ?? 0;

  @override
  String? get password => _password;

  @override
  NERoomItemSettings get settings => _setting ?? NERoomItemSettings();

  @override
  NERoomItemStatus get status => _status;

  @override
  int get updateTime => _updateTime ?? 0;

  @override
  int get createTime => _createTime ?? 0;

  @override
  String? get sipCid => _sipCid;

  set roomUniqueId(int? _meetingUniqueId) {
    this._meetingUniqueId = _meetingUniqueId;
  }

  set roomId(String? roomId) {
    _roomId = roomId;
  }

  @override
  set subject(String? subject) {
    _subject = subject;
  }

  @override
  set startTime(int start) {
    _startTime = start;
  }

  @override
  set endTime(int end) {
    _endTime = end;
  }

  @override
  set password(String? password) {
    _password = password;
  }

  @override
  set settings(NERoomItemSettings setting) {
    _setting = setting;
  }

  set status(NERoomItemStatus status) {
    _status = status;
  }

  set updateTime(int updateTime) {
    _updateTime = updateTime;
  }

  set createTime(int createTime) {
    _createTime = createTime;
  }

  @override
  set live(NEPreRoomLiveInfo? live){
    _live = live;
  }

  @override
  NEPreRoomLiveInfo get live => _live ?? NEPreRoomLiveInfo();

  set sipCid(String? sipCid){
    _sipCid = sipCid;
  }

  @override
  Map toJson() => {
        if (_meetingUniqueId != null) 'meetingUniqueId': _meetingUniqueId,
        'meetingId': _roomId,
        'subject': _subject,
        'startTime': _startTime,
        'endTime': _endTime,
        'password': _password,
        'settings': _setting?.toJson(),
        'status': _status.index,
        'updateTime': _updateTime,
        'createTime': _createTime,
        'sipCid': sipCid,
        'live':_live?.toJson(),
      };

  static _RoomItemImpl _fromJson(Map<dynamic, dynamic>? map) {
    if (map == null) {
      return _RoomItemImpl();
    }
    var impl = _RoomItemImpl();
    impl.roomUniqueId = map['meetingUniqueId'] as int;
    impl.roomId = map['meetingId'] as String?;
    impl.subject = map['subject'] as String?;
    impl.startTime = (map['startTime'] ?? 0) as int;
    impl.endTime = (map['endTime'] ?? 0) as int;
    impl.password = map['password'] as String?;
    impl.settings = NERoomItemSettings.fromJson(map['settings'] as Map?);
    var status = (map['status'] ?? 0) as int;
    impl.status = status >= 0 && status < NERoomItemStatus.values.length ? NERoomItemStatus.values[status] : NERoomItemStatus.invalid;
    impl.updateTime = (map['updateTime'] ?? 0) as int;
    impl.createTime = (map['createTime'] ?? 0) as int;
    impl.live = NEPreRoomLiveInfo.fromJson(map['live'] as Map?);
    impl.sipCid = map['sipCid'] as String?;
    return impl;
  }

  @override
  String toString() => toJson().toString();
}
