// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _AnonymousJoinMeetingRequest {
  /// 应用AppKey
  final String appKey;

  /// app所在域
  final String? domain;

  /// 加入的会议号
  final String meetingId;

  /// 用户昵称
  final String nickName;

  /// 会议密码
  final String? password;

  /// 画面状态 1：打开，2：关闭
  final int video;

  /// 声音状态，1：打开，2：关闭
  final int audio;

  ///会议中的成员标签，自定义，最大长度1024个字符
  final String? tag;

  const _AnonymousJoinMeetingRequest(
      {required this.meetingId,
      required this.nickName,
        this.tag,
      required this.audio,
      required this.video,
      this.password,
      required this.appKey,
      this.domain});

  Map get data => {
        'appKey': appKey,
        if (domain != null) 'appGroupName': domain,
        if (domain != null) 'domain': domain,
        'nickName': nickName,
        if (tag != null) 'memberTag': tag,
        'meetingId': meetingId,
        'video': video,
        'audio': audio,
        'password': password
      };
}
