// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _CreateMeetingRequest {
  /// 用户昵称
  final String nickName;

  /// 如果使用个人会议号，则上传个人会议号， 否则服务器生成
  final String? meetingId;

  /// 会议密码
  final String? password;

  /// 画面状态 1：打开，2：关闭
  final int video;

  /// 声音状态，1：打开，2：关闭
  final int audio;

  /// 聊天室功能开关
  final bool enableChatroom;

  /// 是否开启录制
  final bool cloudRecordOn;

  ///会议中的成员标签，自定义，最大长度1024个字符
  final String? tag;

  ///场景信息
  final Map? scene;

  const _CreateMeetingRequest(
      {required this.nickName,
      this.meetingId,
      this.password,
      this.tag,
      required this.video,
      required this.audio,
      this.enableChatroom = true,
      required this.cloudRecordOn,
      this.scene});

  Map get data => {
        'nickName': nickName,
        if (meetingId != null) 'meetingId': meetingId,
        if (tag != null) 'memberTag': tag,
        if (password?.isNotEmpty ?? false) 'password': password,
        if (password?.isNotEmpty ?? false) 'setPassword': 1,
        'video': video,
        'audio': audio,
        'chatRoom': enableChatroom ? 1 : 0,
        'settings': {
          'attendeeRecordOn': cloudRecordOn,
          if (scene != null) 'scene': scene
        },
      };
}
