// Copyright (c) 2014-2021 NetEase, Inc.
// All right reserved.

part of room_service;

class NEHttpApiRequest {
  final String path;
  final Map<String, dynamic>? headers;
  final Map? body;

  NEHttpApiRequest({
    required this.path,
    this.headers,
    this.body,
  });
}

class _GenericHttpApiRequest extends HttpApi<Map> {

  final NEHttpApiRequest request;

  _GenericHttpApiRequest(this.request);

  @override
  Map data() => request.body ?? Map();

  @override
  String path() => request.path;

  @override
  Map<String, dynamic>? header() => request.headers;

  @override
  result(Map<dynamic, dynamic> map) => map;

}

class _GenericPassThroughApiRequest extends NimPassthroughApi<Map> {

  final NEHttpApiRequest request;

  _GenericPassThroughApiRequest(this.request);

  @override
  Map data() => request.body ?? Map();

  @override
  String path() => request.path;

  @override
  Map<String, dynamic>? header() => request.headers;

  @override
  result(Map<dynamic, dynamic> map) => map;

}