// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _HostControlRequest {
  /// 会议号
  final String meetingId;

  /// 0：剔除，10：主持人禁止成员画面，11：主持人禁止成员声音，12：主持人全体禁音，15：主持人解禁成员画面，
  /// 16：主持人解禁成员声音，17：主持人全体解禁，22：移交主持人，30：主持人指定焦点视频，31：主持人取消焦点视频
  final int actionType;

  /// 操作成员列表
  final List? members;

  const _HostControlRequest({required this.meetingId, required this.actionType, this.members});

  Map get data => {'meetingId': meetingId, 'action': actionType, if (members != null) 'members': members};
}
