// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _JoinMeetingRequest {
  /// 昵称
  final String nickName;

  /// 加入的会议号
  final String meetingId;
  
  /// 会议密码
  final String? password;

  /// 画面状态 1：打开，2：关闭
  final int video;

  /// 声音状态，1：打开，2：关闭
  final int audio;

  ///会议中的成员标签，自定义，最大长度1024个字符
  final String? tag;

  const _JoinMeetingRequest({required this.nickName, required this.meetingId,this.tag, required this.video, required this.audio, this.password});

  Map get data => {
        'nickName': nickName,
        'meetingId': meetingId,
        'memberTag': tag,
        'video': video,
        'audio': audio,
        'password': password
      };
}
