// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _MemberControlRequest {
  /// 会议号
  final String meetingId;

  /// 50：成员关闭自身画面，51：成员关闭自身声音，55：成员打开自身画面，56：成员打开自身声音，
  /// 57：成员同意主持人打开自身画面，58：成员同意主持人打开自己音频,
  /// 60：开启白板，61：关闭白板，62：授予成员白板互动权限，63，撤销成员白板互动权限
  final int actionType;

  /// 操作成员列表
  final List? avRoomUids;

  const _MemberControlRequest({required this.meetingId, required this.actionType, this.avRoomUids});

  Map get data => {
        'meetingId': meetingId,
        'action': actionType,
        if (avRoomUids != null) 'avRoomUids': avRoomUids,
      };
}
