// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;


class AccountSettings {
  BeautySettings? settings;

  AccountSettings({required this.settings});

  factory AccountSettings.fromMap(Map<String, dynamic> map) {
    return AccountSettings(settings: BeautySettings.fromMap(map['settings'] as Map<String, dynamic>));
  }

  Map<String, dynamic> toMap() {
    final beautySettings = settings;
    return {
      if (beautySettings != null) 'settings': beautySettings.toMap(),
    };
  }
}


/// beauty : {'enable':true,'level':1}

class BeautySettings {
  final Beauty beauty;

  BeautySettings({required this.beauty});

  factory BeautySettings.fromMap(Map<String, dynamic> map) {
    return BeautySettings(beauty: Beauty.fromMap((map['beauty'] ?? <String, dynamic>{}) as Map<String, dynamic>));
  }

  Map<String, dynamic> toMap() => {
    'beauty': beauty.toMap(),
  };
}

/// enable : true
/// level : 1

class Beauty {
  final int level;

  Beauty({required this.level});

  factory Beauty.fromMap(Map<String, dynamic> map) {
    return Beauty(level: (map['level'] ?? 0) as int);
  }

  Map<String, dynamic> toMap() => {
    'level': level,
  };
}

