// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class AnonymousJoinMeetingInfo {
  ///应用的appKey
  final String appKey;

  ///im AppKey
  final String imAppKey;

  ///Rtc AppKey
  final String nrtcAppKey;

  /// 三方账号
  final String accountId;

  /// 三方token
  final String accountToken;

  ///匿名帐号公有云IM通信ID
  final String imAccid;

  /// 匿名帐号公有云IM通信ID的密码
  final String imToken;

  /// 昵称
  final String nickName;

  /// 会议信息
  final JoinRoomInfo joinRoomInfo;

  const AnonymousJoinMeetingInfo({
    required this.appKey,
    required this.imAppKey,
    required this.nrtcAppKey,
    required this.accountId,
    required this.accountToken,
    required this.imAccid,
    required this.imToken,
    required this.nickName,
    required this.joinRoomInfo,
  });

  factory AnonymousJoinMeetingInfo.fromMap(Map map) {
    return AnonymousJoinMeetingInfo(
      imAccid: map['imAccid'] as String,
      imToken: map['imToken'] as String,
      nickName: map['nickName'] as String,
      appKey: map['appKey'] as String,
      imAppKey: map['imAppKey'] as String,
      nrtcAppKey: map['nrtcAppKey'] as String,
      accountId: map['accountId'] as String,
      accountToken: map['accountToken'] as String,
      joinRoomInfo: JoinRoomInfo.fromMap(map),
    );
  }

  Map toMap() => {
        'imAccid': imAccid,
        'imToken': imToken,
        'appKey': appKey,
        'imAppKey': imAppKey,
        'nrtcAppKey': nrtcAppKey,
        'accountId': accountId,
        'accountToken': accountToken,
        ...joinRoomInfo.toMap()
      };
}
