// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.
part of room_service;

class _LoginResponse {
  final String accountId;

  final String accountToken;

  final String appKey;

  final String imAccid;

  final String imToken;

  final String imAppKey;

  final String nrtcAppKey;

  /// 匿名用户该字段会为空
  final String? personalMeetingId;

  final String nickname;

  final String? shortId;

  const _LoginResponse({
    required this.accountId,
    required this.accountToken,
    required this.appKey,
    required this.imAccid,
    required this.imToken,
    required this.imAppKey,
    required this.nrtcAppKey,
    this.personalMeetingId,
    required this.nickname,
    this.shortId,
  });

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is _LoginResponse &&
          runtimeType == other.runtimeType &&
          accountId == other.accountId &&
          accountToken == other.accountToken &&
          appKey == other.appKey;

  @override
  int get hashCode =>
      accountId.hashCode ^ accountToken.hashCode ^ appKey.hashCode;

  bool invalid() =>
      accountId.isNotEmpty || accountToken.isNotEmpty || appKey.isNotEmpty;

  factory _LoginResponse.fromMap(Map<dynamic, dynamic> map) {
    return _LoginResponse(
      accountId: map['accountId'] as String,
      accountToken: map['accountToken'] as String,
      appKey: map['appKey'] as String,
      imAccid: map['imAccid'] as String,
      imToken: map['imToken'] as String,
      imAppKey: map['imAppKey'] as String,
      nrtcAppKey: map['nrtcAppKey'] as String,
      personalMeetingId: map['personalMeetingId'] as String?,
      nickname: map['nickname'] as String,
      shortId: map['shortId'] as String?,
    );
  }

}
