// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class NEResult<T> {
  final int code;

  final String? msg;

  final T? data;

  const NEResult({required this.code, this.msg, this.data});

  const NEResult.success(): this(code: RoomErrorCode.success);

  NEResult.successWith(T data): this(code: RoomErrorCode.success, data: data);

  @override
  String toString() {
    return 'code =$code,msg =$msg,data =$data';
  }

  bool isSuccess({aliasCode = RoomErrorCode.success}) {
    return code == aliasCode;
  }

  T get nonNullData => data!;
}
