// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

/// 预定房间item
abstract class NERoomItem {
  factory NERoomItem.createScheduleRoomItem() => _RoomItemImpl();

  factory NERoomItem() => _RoomItemImpl();

  NERoomItem._();

  /// 预定成功后， 服务器生成唯一id
  int? get roomUniqueId;

  /// 预定成功后会议号
  String? get roomId;

  /// 设置会议主题
  set subject(String? subject);

  /// 获取会议主题
  String? get subject;

  /// 设置会议开始时间， 毫秒
  set startTime(int start);

  /// 获取会议开始时间
  int get startTime;

  /// 设置会议结束时间， 毫秒
  set endTime(int end);

  /// 获取会议结束时间
  int get endTime;

  /// 设置会议密码， 为空表示不设置密码
  set password(String? password);

  /// 获取会议密码
  String? get password;

  /// 预定会议参数设置
  set settings(NERoomItemSettings setting);

  /// 获取会议参数设置
  NERoomItemSettings get settings;

  /// 会议状态
  NERoomItemStatus get status;

  /// 数据变更时间，初始为创建时间
  int get updateTime;

  /// 数据创建时间
  int get createTime;

  /// 设置直播信息
  set live(NEPreRoomLiveInfo? live);

  /// 获取直播信息
  NEPreRoomLiveInfo get live;

  /// sip 入会id
  String? get sipCid;

  Map toJson();

  static NERoomItem fromJson(Map<dynamic, dynamic> map) {
    return _RoomItemImpl._fromJson(map);
  }
}
