// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

/// enter chat room
class ChatRoomEnterApi extends NimApi<EnterChatRoomResultData> {
  EnterChatRoomData roomData;

  int retryCount;

  RoomLinkAddress? linkAddress;

  ChatRoomEnterApi(this.roomData, this.retryCount, {this.linkAddress});

  @override
  void _execute(Completer<NEResult<EnterChatRoomResultData>> completer) {
    NimPlugin().getChatRoomService().enterChatRoom(roomData, retryCount, (int code, EnterChatRoomResultData? data) {
      completer.complete(NEResult(code: code, data: data));
    }, linkAddress: linkAddress);
  }
}
