// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

/// 获取会议状态
///
/// 接口说明:
/// 获取会议中当前成员信息。
/// * 可以获取占位中与参会中的成员，这里有个无法避免的情况是，会有成员获取了加入信息，占了位，
/// 但是没有加入音视频房间。导致列表比真正会议中的人多，所以由端测根据接收到的加入音视频房间的通知，维护一个正确的列表
class _MeetingInfoApi extends NimPassthroughApi<MeetingInfo> {
  _MeetingInfoRequest request;

  _MeetingInfoApi(this.request);

  @override
  String path() => '/v1/sdk/meeting/info';

  @override
  MeetingInfo result(Map map) => MeetingInfo.fromMap(request.meetingId, map);

  @override
  Map data() => request.data;
}
