// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class _ServerControlApi extends _NimStreamApi<MeetingAction> {
  _ServerControlApi._internal() : super();

  static final _ServerControlApi _singleton = _ServerControlApi._internal();

  factory _ServerControlApi() => _singleton;

  void _dataConvert(PassthroughNotifyData data) {
    Alog.d(
        tag: _tag,
        moduleName: _moduleName,
        content: 'ServerControlApi receive data = ${data.body}');
    var action = ActionFactory.buildAction(data);
    if (action != null) {
      _notify(action);
    }
  }

  @override
  void _startListen() {
    NimPlugin().getPassthroughObserver().registerNotifyData(_dataConvert);
  }

  @override
  void _stopListen() {
    NimPlugin().getPassthroughObserver().unregisterNotifyData(_dataConvert);
  }
}
