// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

abstract class _NimStreamApi<T> {
  late Stream<T> stream;

  late StreamController<T> controller;

  _NimStreamApi() {
    controller = StreamController<T>.broadcast(
      onListen: _startListen,
      onCancel: _stopListen,
    );
    stream = controller.stream;
  }

  Stream<T> listen() {
    return stream;
  }

  void _notify(T data) {
    controller.add(data);
  }

  void _startListen();

  void _stopListen();
}
