// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class AuthRepository {

  /// sdk登陆状态
  static Stream<int> get onlineStatusChanged => _AuthManager().obAuthState();
  /// im在线状态
  static Stream<StatusCode> get imOnlineStatusChanged => NimApiHelper._onOnlineStatusChanged;

  static Future<NEResult<void>> loginWithToken(String accountId, String token) => _AuthManager().loginWithToken(accountId, token);

  static Future<NEResult<void>> loginWithNEMeeting(String username, String password) => _AuthManager().loginWithNEMeeting(username, password);

  static Future<NEResult<void>> loginWithSSOToken(String ssoToken) => _AuthManager().loginWithSSOToken(ssoToken);

 /// 尝试自动登陆
 static Future<NEResult<void>> tryAutoLogin() => _AuthManager().autoLoginWithLocalToken();

  static void logout() => _AuthManager().logout();

  static bool isAuthorized() => !UserProfile.isAnonymous && _AuthManager()._authState == AuthState.authorized;
}
