// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class ChatRoomRepository {
  /// 发送聊天室消息
  static Future<NEResult<void>> sendChatRoomMessage(ChatRoomMessage message) =>
      ChatRoomApiHelper._sendChatRoomMessage(message);

  /// 进入聊天室
  static Future<NEResult<EnterChatRoomResultData>> enterChatRoom(EnterChatRoomData data, int retryCount,
          {RoomLinkAddress? linkAddress}) =>
      ChatRoomApiHelper._enterChatRoom(data, retryCount, linkAddress: linkAddress);

  /// exit chat ro
  static Future<NEResult<void>> exitChatRoom(String roomId) => ChatRoomApiHelper._exitChatRoom(roomId);

  /// chat room message receive
  static Stream<List<ChatRoomMessage>> get chatRoomReceiveMessage => ChatRoomApiHelper._chatRoomReceiveMessage;

  /// fet room link address
  static Future<NEResult<List<String>>> fetchRoomLink(String roomId) {
    return HttpApiHelper._fetchRoomLink(roomId);
  }

  static Future<NEResult<void>> updateChatRoomRole(String roomId, String nick, String? avatar,
      Map<String, dynamic>? extension, bool needSave) =>
      ChatRoomApiHelper._updateChatRoomRole(roomId,
          ChatRoomMemberUpdate()
            ..nick = nick
            ..avatar = avatar
            ..extension = extension
            ..needSave = needSave
      );

}
