// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

/// 会议前服务
class PreRoomRepository {

  ///预约会议
  static Future<NEResult<NERoomItem>> scheduleRoom(NERoomItem item) {
    return HttpApiHelper._scheduleRoom(item);
  }

  ///编辑预约会议
  static Future<NEResult<NERoomItem>> editRoom(NERoomItem item) {
    return HttpApiHelper._editRoom(item);
  }

  ///取消预约会议，开始前可以取消
  static Future<NEResult<void>> cancelRoom(int roomUniqueId) {
    return HttpApiHelper._cancelRoom(roomUniqueId);
  }

  ///删除预约会议
  static Future<NEResult<void>> deleteRoom(int roomUniqueId) {
    return HttpApiHelper._deleteRoom(roomUniqueId);
  }

  ///根据唯一id获取会议信息
  static Future<NEResult<NERoomItem>> getRoomItemById(int roomUniqueId) {
    return HttpApiHelper._getRoomItemById(roomUniqueId);
  }

  ///根据会议状态查询会议信息列表，
  static Future<NEResult<List<NERoomItem>>> getRoomList(List<NERoomItemStatus> status) {
    return HttpApiHelper._getRoomList(status);
  }
}
