// Copyright (c) 2014-2020 NetEase, Inc.
// All right reserved.

part of room_service;

class ServiceRepository {
  /// 服务初始化
  static Future<bool> initialize(
      String appKey, String? domain, bool reuseNIM, String? nimSDKDir) async {
    return await DeviceInfo.initialize().then((value) {
      EventTrack().init(AppInfo(appKey, 'meeting', {'sdk_version': SDKConfig.sdkVersion}));
      EventTrack().addPropertyContributor(() => {
        // user info
        'uid': UserProfile.accountId,
        'nickname': UserProfile.displayName,
        //device id
        'sdk_device_id': DeviceInfo.deviceId,
      });
    }).then((value) {
      return _AuthManager().initialize(appKey, domain, reuseNIM, nimSDKDir);
    }).catchError((e,s) {
      Alog.e(
        tag: 'ServiceRepository',
        moduleName: _moduleName,
        content: 'initialize error: $e\n$s',
      );
      return false;
    });
  }
}
